<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<% try { // START: DEBUG %>
<%@ page errorPage="/errorPage.jsp" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/citation.tld" prefix="citation" %>

<html:xhtml />
<%@ page import="java.util.Iterator" %>
<%@ page import="javax.servlet.http.HttpServletRequest" %>
<%@ page import="javax.servlet.http.HttpServletResponse" %>
<%@ page import="com.sas.apps.citation.controller.action.CitationDialogAction" %>
<%@ page import="com.sas.apps.citation.model.user.SessionScopeManager" %>


<%@ page import="com.sas.apps.citation.util.CommonUtils" %>
<%@ page import="com.sas.apps.citation.view.beans.RepairReportFormBean" %>
<%@ page import="com.sas.apps.citation.view.beans.PagePropertyBean" %>
<%@ page import="com.sas.apps.citation.view.help.HelpUtils" %>
<%@ page import="com.sas.apps.citation.view.tbeans.html.CitationButton" %>
<%@ page import="com.sas.apps.citation.view.util.PageErrorProcessor" %>
<%@ page import="com.sas.apps.citation.view.util.ViewUtils" %>

<%@ page import="com.sas.apps.citation.view.beans.reportmanagement.DamagedResource" %>

<%@ page import="com.sas.servlet.tbeans.html.TreeView" %>
<%@ page import="com.sas.servlet.tbeans.html.TreeViewFull.RemoteScriptForm" %>

<%@ page import="com.sas.apps.citation.view.beans.BeanValidator" %>
<%@ page import="com.sas.apps.citation.view.beans.BeanValidator.BeanValidatorXSSException" %>


<%
    Object rc = request.getAttribute(CitationDialogAction.RESULT_CODE_KEY);
    Object cmdKey = request.getAttribute(CitationDialogAction.DIALOG_CMD_KEY);
    if( CitationDialogAction.RC_SUCCESS.equals(rc)
        && CitationDialogAction.CMD_OK_DIALOG_KEY.equals(cmdKey))
    { 
%>
<script type="text/javascript">
/*<![CDATA[*/
    var winOpener = self.opener;  <%-- close the dialog since the commit was successful --%>
    if( winOpener != null && winOpener.cwDialogManager != null) {
        winOpener.cwDialogManager.closeDialogWindow( self ); <%-- op succeeded so close the dialog and dispatch WINDOW_CLOSING & WINDOW_CLOSED events --%>
    } else {
        cwDialogManager.closeDialogWindow( self );
    }
/*]]>*/
</script>

<%
        return; //exit out of service() method. Nothing left to do so everything else is a waste of time.
    }
%>
<script type="text/javascript" src="scripts/citation_repairReport.js"></script>

<jsp:useBean id="repairReportForm" class="com.sas.apps.citation.view.beans.RepairReportFormBean" scope="session"/>

<%
    CitationButton okButton = CitationButton.createStandaloneButton(request, "okButton",
            PagePropertyBean.getLabelWithMnemonic(pageContext,"ok.button.txt"),
            "dialogSubmit();");
    request.setAttribute(CitationButton.OK_DIALOG_BUTTON, okButton);

    CitationButton cancelButton = CitationButton.createStandaloneButton(request, "cancelButton",
        PagePropertyBean.getLabelWithMnemonic(pageContext,"cancel.button.txt"),
        "cwDialogManager.cancelSelf();");
    request.setAttribute(CitationButton.CANCEL_DIALOG_BUTTON, cancelButton);
    HelpUtils.createHelpButton(request, HelpUtils.HELP_REPAIR_REPORT);

    String authoritativeFormAction = (String) request.getAttribute("FORM_ACTION");
    if (authoritativeFormAction == null)
    {
        authoritativeFormAction = "repairReport.do"; //default
    }
    
    String reportNameLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.report.label.txt");
    String reportLocationLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.location.label.txt");
    String originalMapLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.original.map.label.txt");
    String notFoundLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.map.not.found.label.txt");
    String reportSectionsLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.report.section.label.txt");
    String browseButtonText = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.browse.button.txt");
    String correctMapLabel = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.correct.map.label.txt");    
    
    String reportName = repairReportForm.getReportName();
    String reportPath = repairReportForm.getReportPath();
    
	try
	{
		BeanValidator.validateGeneralStringContent(reportName);
		BeanValidator.validateGeneralStringContent(reportPath);
	} catch (BeanValidatorXSSException e)
	{
		throw new IllegalArgumentException("SECURITY VIOLATION: potential cross-site scripting detected");
	}

    DamagedResource[] damagedResources =  repairReportForm.getDamagedResource();
    
%>
<div id="repairReport_contentDiv">
<citation:form action="<%=authoritativeFormAction%>" >
<html:hidden styleId="dialogCommandField" property="<%=CitationDialogAction.DIALOG_CMD_KEY %>" value="<%=CitationDialogAction.CMD_OK_DIALOG_KEY %>"/>
  
    <table id="repairReport_reportLayout" style="width:100%" summary="">
        <tr>
            <td class="header"><%=reportNameLabel %></td>
            <td class="repairReport_reportValueCell"><span class="label"><%=reportName %></span></td>
        </tr>
        <tr>
            <td class="header"><%=reportLocationLabel %></td>
            <td class="repairReport_reportValueCell" style="white-space:normal;"><span class="label"><%=reportPath %></span></td>
        </tr>
    </table>

    <!-- ***** Start of outer scrollable area containing all maps and section lists *****-->
    <div id="repairReport_MapsEditingDiv">
        <table id="repairReport_MapsAndSectionsLayout">

<%
    if (damagedResources.length > 0)    // Have any maps at all in the report?
    {
        DamagedResource damagedResource = null;
        String oldResourcePathAndName = "";
        String newResourcePathAndName = "&nbsp;";
        String resourceStatus = "";
        String referenceSection = null;
        String iDamagedResourceStr = null;
        String correctResourceProperty = null;
        String correctResourceId = null;
        for (int iDamagedResource=0; iDamagedResource < damagedResources.length; iDamagedResource++)
        {
            iDamagedResourceStr = Integer.toString(iDamagedResource);
            correctResourceProperty = "correctResource[" + iDamagedResourceStr + "]";
            correctResourceId = "correctResource_"+ iDamagedResourceStr;
            damagedResource = damagedResources[iDamagedResource];
            oldResourcePathAndName = repairReportForm.getInformationMapPathAndName(iDamagedResource);
			
			try
			{
				BeanValidator.validateGeneralStringContent(oldResourcePathAndName);
			} catch (BeanValidatorXSSException e)
			{
				throw new IllegalArgumentException("SECURITY VIOLATION: potential cross-site scripting detected");
			}
			
            if (1 != damagedResource.getStatus()) {     // Is map un-reachable?
                resourceStatus = " <span class=\"repairReport_notFound\">" + notFoundLabel + "</span>";
                newResourcePathAndName = "&nbsp;";
            }
            else {  // Map exists
                resourceStatus = "";
                newResourcePathAndName = oldResourcePathAndName;            
            }
%>

            <tr>
                <td class="repairReport_mapEditCell">
                    <table class="repairReport_mapEditLayout" summary="">
                        <tr>
                            <td colspan="2" class="repairReport_mapEditLabelCell"><span class="header"><%=originalMapLabel %> <%=resourceStatus %></span></td>
                        </tr>
                        <tr>
                            <td colspan="2" class="repairReport_oldPathNameCell"><%=oldResourcePathAndName %></td>
                        </tr>
                        <tr>
                            <td colspan="1"><span class="header"><%=correctMapLabel %></span></td>
                            <td class="repairReport_browseButtonCell">
<%
        CitationButton browseButton = CitationButton.createStandaloneButton(request, "repairReport_browseButton_" + iDamagedResourceStr,
                    browseButtonText,
                    "onRepairReportClickBrowse(event, " + iDamagedResourceStr + ")"
                    );
        browseButton.write(out);
%>

                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" class="repairReport_newPathNameCell" >
                                <span id="correctResourceSpan_<%=iDamagedResourceStr %>"><%=newResourcePathAndName%></span>
                                <html:hidden property="<%=correctResourceProperty%>" styleId="<%=correctResourceId%>"/>
                            </td>
                            
                        </tr>
                    </table>
                </td>
                <td class="repairReport_sectionListCell">
                    <span class="header"><%=reportSectionsLabel %></span>
                    <div class="repairReport_sectionList">
        
<%
            Iterator itr = damagedResource.getReferenceSections().iterator();
            while (itr.hasNext())
            {
                referenceSection = itr.next().toString();
%>          
                        <%=referenceSection %><br />
<%
            }   // while
%>
                    </div>
                <td>
            </tr>
            <tr>
                <td colspan="2" class="repairReport_rowSpacer">&nbsp;</td>
            </tr>
        
<%
        }   // for
    }
    else    // No info maps at all referenced in the report
    {
        String noReportsMsg = PagePropertyBean.getMessage(pageContext, "repair.report.dialog.no.information.maps.txt");
%>        
        <tr>
          <td><%=noReportsMsg%></td>
        </tr>
<%        
    }
%>
        </table>
    </div>
    <!-- ***** End of outer scrollable are containing all maps and section lists *****-->
    
	<html:hidden property="urlToConvert" styleId="urlToConvert"/>

</citation:form>
</div>

<% } catch (Exception ex) {
    PageErrorProcessor.setJspError(ex, pageContext, out);
} // END: DEBUG 
%>




